/**
 * Copyright 2016 Amazon.com, Inc. or its affiliates. All Rights Reserved.
 */

(function ()
{
	log.lifecycle("Launching Blast");

	var fontPackagesToInstall =
	[
		"casual",
		"cursive",
		"monospacesansserif",
		"monospaceserif",
		"proportionalsansserif",
		"proportionalserif",
		"smallcapitals",
		"soma"
	];

	var baseFontsPath = plugins.resolvePath(
			"static://com.amazon.ignition.app.stark/assets/fonts");
	for (var i=0; i<fontPackagesToInstall.length; i++)
	{
		font.installFontPackage(fontPackagesToInstall[i], baseFontsPath);
	}

	global.appLoadMetrics = {};
	global.appLoadMetrics.requests = {};
	global.appLoadMetrics.includes = {};
	global.appLoadMetrics.appStartupTime = metrics.getNowTimestamp();

	function require(file)
	{
		var oldModule = global.module;
		var oldRequire = global.require;
		global.module = {exports: {}};
		global.require = require;
		include(file);
		var exports = global.module.exports;
		global.module = oldModule;
		global.require = oldRequire;
		return exports;
	}

	var commandLineArgs = global.commandLine && global.commandLine.args || {};
	global.deviceAffinity = (require("./deviceAffinity.js")).calculateDeviceAffinity(
			global.deviceinfo, global.plugins, commandLineArgs);

	var options = require('./config.js')();
	var createStateManager = require('./stateManager.js');

	var stateManager = createStateManager(options);
	stateManager.start();

}());
