/**
 * Copyright 2016 Amazon.com, Inc. or its affiliates. All Rights Reserved.
 */

(function()
{
	function TextToSpeech() {};

	TextToSpeech.prototype.speak = function(text, language)
	{
		if (typeof texttospeech !== 'undefined' && texttospeech && this._isTextToSpeechEnabled())
		{
			language = language || this._getDefaultLanguage();
			text = this._parseMessage(text);
			this._speak(text, language);
		}
	};

	TextToSpeech.prototype._isTextToSpeechEnabled = function()
	{
		return texttospeech.isSpeakingEnabled();
	};

	TextToSpeech.prototype._getDefaultLanguage = function()
	{
		return "en-US";
	};

	TextToSpeech.prototype._parseMessage = function(text)
	{
		// TODO: this fixes a PS4 bug in which it doesn't say the '/' character.
		// Ideally this would be fixed in Ignition but for updatability it
		// was decided to do it here.
		// SIM: https://sim.amazon.com/issues/BLASTINTERP-1500
		return text.replace("/", " slash ");
	};

	TextToSpeech.prototype._speak = function(text, language)
	{
		texttospeech.speak(text, language, true);
	};

	module.exports = TextToSpeech;
}());
