/* Copyright 2017 Amazon.com, Inc. or its affiliates. All Rights Reserved. */

#ifndef PLUGIN_DEVICEINFO_DEVICEINFO_IDENTITY_I_PLATFORM_SERVICES_PROVIDER_H_
#define PLUGIN_DEVICEINFO_DEVICEINFO_IDENTITY_I_PLATFORM_SERVICES_PROVIDER_H_

#include "deviceinfo/services/PlatformService.h"

#include "DataStructures.h"
#include "SmartPointers.h"

#include <string>

namespace ignition
{
namespace deviceinfo
{
namespace services
{

class IPlatformServicesProvider;
typedef core::memory::SharedPtr<IPlatformServicesProvider> IPlatformServicesProviderPtr;

class IPlatformServicesProvider
{
public:
	virtual ~IPlatformServicesProvider() {}
	virtual core::vector<PlatformServicePtr> getServices() = 0;

};

} // namespace services
} // namespace deviceinfo
} // namespace ignition

#endif // PLUGIN_DEVICEINFO_DEVICEINFO_IDENTITY_I_PLATFORM_SERVICES_PROVIDER_H_
