/* Copyright 2014 Amazon.com, Inc. or its affiliates. All Rights Reserved. */

#ifndef PLUGIN_NETWORK_SERVICES_DATABASE_H_
#define PLUGIN_NETWORK_SERVICES_DATABASE_H_

#include "DataStructures.h"
#include "Servent.h"

#include <string>

namespace ignition
{
namespace network
{

class ServicesDatabase
{
public:
	ServicesDatabase();
	servent* getEntryForName(std::string name);
	servent* getEntryForPort(int port, const char* proto);
private:
	void _populateMaps();
	core::vector<servent> _buildEntriesVector() const;

	const core::vector<servent> _entries;
	core::map<int, servent*> _portToEntryMap;
	core::map<std::string, servent*> _nameToEntryMap;
};

} // namespace network
} // namespace ignition

#endif // PLUGIN_NETWORK_SERVICES_DATABASE_H_