local EffectFactory = plugins.style:lazyRequire('effects.EffectFactory')
local PropertyTypes = plugins.style:lazyRequire('rules.styles.definitions.PropertyTypes')
local Vec2 = plugins.style:lazyRequire('expressions.definitions.types.Vec2Type')
local Vec4 = plugins.style:lazyRequire('expressions.definitions.types.Vec4Type')

return EffectFactory.createEffectDefinition('border',
{
	{
		name = 'u_border_scale',
		type = PropertyTypes.VEC2,
		default = Vec2(1.0, 1.0)
	},
	{
		name = 'u_border_midpoint',
		type = PropertyTypes.VEC2,
		default = Vec2(0.5, 0.5)
	},
	{
		name = 'u_border_color',
		type = PropertyTypes.VEC4,
		default = Vec4(1.0, 1.0, 1.0, 1.0);
	}
})
