
local EffectFactory = plugins.style:lazyRequire('effects.EffectFactory')
local PropertyTypes = plugins.style:lazyRequire('rules.styles.definitions.PropertyTypes')
local Vec2 = plugins.style:lazyRequire('expressions.definitions.types.Vec2Type')
local Vec4 = plugins.style:lazyRequire('expressions.definitions.types.Vec4Type')

return EffectFactory.createEffectDefinition('lineargradient',
{
	{
		name = 'u_direction',
		type = PropertyTypes.VEC2,
		default = Vec2(1.0, 0.0)
	},
	{
		name = 'u_offset',
		type = PropertyTypes.FLOAT,
		default = 0.0
	},
	{
		name = 'u_length',
		type = PropertyTypes.FLOAT,
		default = 1.0
	},
	{
		name = 'u_colour_min',
		type = PropertyTypes.VEC4,
		default = Vec4(0.0, 0.0, 0.0, 0.0);
	},
	{
		name = 'u_colour_max',
		type = PropertyTypes.VEC4,
		default = Vec4(1.0, 1.0, 1.0, 1.0);
	}
})
