
local EffectFactory = plugins.style:lazyRequire('effects.EffectFactory')
local PropertyTypes = plugins.style:lazyRequire('rules.styles.definitions.PropertyTypes')
local Vec3 = plugins.style:lazyRequire('expressions.definitions.types.Vec3Type')

return EffectFactory.createEffectDefinition('sphericalalpha',
{
	{
		name = 'u_sphericalalpha_position_WS',
		type = PropertyTypes.VEC3,
		default = Vec3(0.0, 0.0, 0.0)
	},
	{
		name = 'u_sphericalalpha_inner_alpha_value',
		type = PropertyTypes.FLOAT,
		default = 1.0
	},
	{
		name = 'u_sphericalalpha_outer_alpha_value',
		type = PropertyTypes.FLOAT,
		default = 0.0
	},
	{
		name = 'u_sphericalalpha_inner_alpha_radius',
		type = PropertyTypes.FLOAT,
		default = 0.0
	},
	{
		name = 'u_sphericalalpha_outer_alpha_radius',
		type = PropertyTypes.FLOAT,
		default = 1.0
	}
})
