-- Copyright 2015 Amazon.com, Inc. or its affiliates. All Rights Reserved.

local IBehaviour = class(function(self)
end)

-- Called by view implementations in order to add any
-- extra options to an iteration option list
function IBehaviour:complementIteratorOptions(iteratorOptions)
	error("IBehaviour:complementIteratorOptions() is not implemented!")
end

-- May be used to change elements position inside a views list when changing
-- from one position to another. Can be used to rotate or sort the list.
function IBehaviour:adjustElementsPosition(iterationViews, oldActiveIndex, newActiveIndex)
	error("IBehaviour:adjustElementsPosition() is not implemented!")
end

return IBehaviour
