#version 100

// u_color is the rgba color of this rectangle
uniform lowp vec4 u_color;
uniform mediump vec4 transform;
uniform mediump float radius;

varying mediump vec2 pixel_pos;

void main(void)
{
    mediump float t = 1.0;

    if (pixel_pos.y < radius)
    {
        if (pixel_pos.x < radius)
        {
            mediump float d = distance(pixel_pos, vec2(radius, radius));
            t = clamp(0.5 - d + radius, 0.0, 1.0);
        }
        else if (pixel_pos.x > transform.z - radius)
        {
            mediump float d = distance(pixel_pos, vec2(transform.z - radius, radius));
            t = clamp(0.5 - d + radius, 0.0, 1.0);
        }
    }
    else if (pixel_pos.y > transform.w - radius)
    {
        if (pixel_pos.x < radius)
        {
            mediump float d = distance(pixel_pos, vec2(radius, transform.w - radius));
            t = clamp(0.5 - d + radius, 0.0, 1.0);
        }
        else if (pixel_pos.x > transform.z - radius)
        {
            mediump float d = distance(pixel_pos, vec2(transform.z - radius, transform.w - radius));
            t = clamp(0.5 - d + radius, 0.0, 1.0);
        }
    }

    gl_FragColor = vec4(u_color.r / 255.0,
                        u_color.g / 255.0,
                        u_color.b / 255.0,
                        u_color.a / 255.0 * t);
}